/*
Copyright (C) 2000 David G. Watson

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
	 
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
				  
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/


#include "mainwin.h"

#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>

static const char* const image0_data[] = { 
"22 22 121 2",
"Qt c None",
".# c #000000",
"#N c #080400",
".s c #101008",
"#Y c #101010",
"#X c #101410",
".r c #181008",
".q c #181010",
"#G c #181410",
"#a c #181818",
".H c #201808",
"#1 c #202420",
".b c #291810",
".a c #291c10",
"#2 c #292429",
"#B c #292829",
"#0 c #292c29",
".G c #311c10",
"#Z c #312c29",
"#S c #312c31",
"#l c #313431",
".F c #392018",
".h c #392410",
".p c #392810",
".c c #392818",
".0 c #393439",
"#J c #393831",
".i c #412818",
".E c #4a2c18",
".C c #4a3018",
".D c #523018",
".2 c #523020",
"#m c #523418",
".B c #523420",
"#d c #52504a",
".L c #525052",
"#v c #5a5052",
"#W c #625d5a",
"## c #626162",
"#M c #6a696a",
"#O c #73696a",
"#t c #736d6a",
"#k c #7b7d7b",
".A c #835529",
"#. c #838183",
"#j c #8b8d8b",
".9 c #948d8b",
"#s c #948d94",
"#F c #949194",
"#V c #949594",
".8 c #9c959c",
"#A c #9c999c",
"#R c #9c9d9c",
"#u c #a46d39",
"#i c #a49d9c",
"#T c #a49da4",
"#U c #a4a19c",
".7 c #a4a1a4",
"#h c #a4a5a4",
".K c #ac6d39",
"#c c #ac7139",
"#Q c #acaaa4",
".6 c #acaaac",
".Z c #acaeac",
"#K c #b4aeb4",
".Y c #b4b2b4",
".X c #b4b6b4",
"#H c #bd7941",
"#z c #bdb6b4",
"#L c #bdb6bd",
"#g c #bdbab4",
".5 c #bdbabd",
".W c #bdbebd",
"#P c #c5bebd",
"#r c #c5bec5",
".V c #c5c2c5",
"#q c #c5c6c5",
"#E c #cdc6cd",
"#y c #cdcac5",
".U c #cdcacd",
"#C c #d5cecd",
"#I c #d5ced5",
".T c #d5d2cd",
"#n c #d5d2d5",
".4 c #d5d6d5",
"#p c #ded6d5",
"#x c #dedad5",
".S c #dedade",
".R c #dedede",
"#D c #e6dede",
"#w c #e6dee6",
"#e c #e6e2e6",
".3 c #e6e6e6",
".j c #eea56a",
"#o c #eee6e6",
".Q c #eee6ee",
".P c #eeeaee",
"#f c #eeeeee",
".z c #f6a15a",
".1 c #f6a55a",
".d c #f6ae6a",
".O c #f6f2f6",
".M c #f6f6f6",
".x c #ffae62",
"#b c #ffb26a",
".w c #ffb66a",
".J c #ffb673",
".g c #ffba73",
".o c #ffba7b",
".f c #ffc27b",
".v c #ffc283",
".e c #ffc683",
".t c #ffc68b",
".n c #ffca8b",
".I c #ffca94",
".k c #ffce9c",
".u c #ffd294",
".m c #ffd29c",
".l c #ffd69c",
".y c #ffd6a4",
".N c #fffaff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.#.#.#.#.#QtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.#.#.#.#.#.#.#.#.#Qt.#QtQtQtQt",
"QtQtQtQtQtQt.#.#QtQtQtQtQtQt.#.#.#.#QtQtQtQt",
"QtQtQtQtQt.#QtQtQtQtQtQtQtQtQt.#.#.#QtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQt.#.#.#.#QtQtQtQt",
"QtQt.a.a.a.bQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"Qt.c.d.e.f.g.hQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
".i.j.k.l.m.n.o.p.q.r.r.s.q.r.r.sQtQtQtQtQtQt",
".h.t.l.u.v.w.x.x.x.x.x.x.x.x.x.x.hQtQtQtQtQt",
".i.n.y.v.z.A.B.C.D.C.E.i.i.h.F.G.a.H.#.#.#.#",
".h.n.I.J.K.L.M.N.M.O.P.Q.R.S.T.U.V.W.X.Y.Z.0",
".i.t.t.1.2.U.P.3.Q.S.4.U.V.5.Y.6.7.8.9#.###a",
".h.t#b#c#d.M#e#f.P.Q.R.4.U.V#g.Y#h#i#j#k#lQt",
".i.g.z#m#n.4#o.P.P.3#e#p#n#q#r.Y.6#i#s#t.#Qt",
".h.w#u#v.R#p#e.Q#e#w#x#n#y.V#z.Y#h#A#.#BQtQt",
".i.1.D.Z#C.4#e.R#D#p#n.U#E.5#z.6.7#F###GQtQt",
".h#H#d#n#q#n.4.4#n#I#y.V.5#z.Z#h#A#.#JQtQtQt",
".i.E#K.X.V#q.U.U.U#q.V.5#L.Z.6#i#F#M.#QtQtQt",
"#N#O.U#K.Y.5.5#P.5.5.Y.Y#Q#h#R#F#k#SQtQtQtQt",
"#a#F#T#A#T.7.7#U.7#A#A#V#F#j.9#k#W#XQtQtQtQt",
"#Y#l#B#Z#0#S#0#S#0#S#B#0#B#B#1#2#YQtQtQtQtQt"};

static const char* const image1_data[] = { 
"22 22 64 1",
". c None",
"o c #000000",
"h c #080008",
"a c #083c52",
"U c #087594",
"1 c #0899b4",
"P c #08a1bd",
"z c #08b2cd",
"Z c #08bacd",
"s c #08bad5",
"0 c #08bed5",
"D c #08c2d5",
"# c #103c5a",
"2 c #104862",
"T c #105073",
"Q c #106d8b",
"n c #107594",
"G c #107994",
"B c #10799c",
"F c #10819c",
"6 c #1099b4",
"w c #10b2cd",
"5 c #10b6d5",
"7 c #10bad5",
"O c #10c2d5",
"y c #10c6de",
"S c #18617b",
"R c #186583",
"8 c #18bed5",
"E c #18cede",
"t c #18d2de",
"g c #2085a4",
"v c #20c2d5",
"N c #29bede",
"r c #29c6de",
"Y c #31c6de",
"4 c #39c6de",
"x c #39dade",
"A c #41dee6",
"K c #52aac5",
"b c #5aaecd",
"M c #5ac6de",
"J c #62b2cd",
"u c #73d2e6",
"I c #7bbad5",
"H c #7bbed5",
"q c #7bd2e6",
"m c #8bd6e6",
"9 c #8bdaee",
"k c #94d2e6",
"X c #94daee",
"j c #9cdaee",
"L c #9cdeee",
"l c #ace2ee",
"3 c #b4f2ff",
"C c #bde6f6",
"W c #c5eeff",
"V c #cdf2ff",
"c c #d5eaf6",
"f c #deeaff",
"i c #e6f6ff",
"e c #f6f6ff",
"d c #f6faff",
"p c #ffffff",
"......................",
"......................",
"......................",
".......#a#a#a#a.......",
".......abcdefgh.......",
".......#ijklmno.......",
".......apqrstnh.......",
".......#puvwxno.......",
".......apqyzABh.......",
"..a#a#a#CuDwEFooohoo..",
"..hGHIJKLMNzOPBQRSTo..",
"...hUViWXYZwz0Et12o...",
"....hG3u4s5zwDA62o....",
".....hU3D7zwDA12o.....",
"......hG3D7DA62o......",
".......hU38A12o.......",
"........hG962o........",
".........hU2o.........",
"..........ho..........",
"......................",
"......................",
"......................"};

static const char* const image2_data[] = { 
"22 22 91 2",
"Qt c None",
".9 c #000000",
".7 c #000008",
".5 c #000408",
"#y c #001018",
"#x c #001420",
"#i c #001829",
".4 c #080008",
"#c c #080408",
".6 c #080410",
".8 c #080810",
".a c #080c18",
".H c #081018",
".d c #081420",
"#n c #081829",
"#k c #081c29",
"#b c #082031",
".# c #083c52",
".n c #08405a",
".t c #084462",
".h c #08506a",
".2 c #085d7b",
"#w c #086d8b",
".0 c #087994",
".l c #08b2cd",
".N c #08b6cd",
"#d c #103c5a",
".3 c #104c6a",
".1 c #10698b",
"#t c #106d8b",
".Q c #107194",
"#a c #107594",
".V c #10819c",
".G c #1081a4",
".s c #1089ac",
".m c #108dac",
".g c #1095b4",
".Z c #109dbd",
"#r c #10a5c5",
".C c #10b2cd",
".Y c #10b6cd",
".O c #10b6d5",
".D c #10cade",
".w c #10cede",
".F c #18b6cd",
".y c #18bacd",
".B c #18c2de",
".v c #18c6de",
"#s c #18cee6",
"#m c #18dade",
".r c #20dae6",
".x c #20dee6",
".R c #295073",
"#u c #295973",
".U c #296d8b",
"#v c #297194",
".M c #29c2de",
"## c #29d6e6",
".c c #31597b",
".X c #31c2d5",
".q c #31cade",
".u c #31d6e6",
".W c #39aec5",
".A c #39cade",
".P c #39e6ee",
"#q c #41b2cd",
"#h c #41e2e6",
".T c #4a7194",
".E c #4ae6ee",
".L c #52bad5",
".S c #627d9c",
"#p c #62bed5",
"#g c #62cade",
"#j c #6acee6",
".I c #73a5c5",
".z c #7b99bd",
".b c #7b9dbd",
".i c #7ba1bd",
".o c #83a5c5",
"#. c #83deee",
"#l c #83e6f6",
".e c #8baecd",
".K c #8bc2de",
"#f c #8be6f6",
".p c #94d6e6",
".k c #94d6ee",
"#e c #cdf2ff",
"#o c #d5f2ff",
".f c #def2ff",
".J c #e6f6ff",
".j c #ffffff",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQt.#.aQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQt.#.b.c.dQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQt.#.e.f.g.h.dQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.#.i.j.k.l.m.n.dQtQtQtQtQtQtQt",
"QtQtQtQtQtQt.#.o.j.p.q.r.l.s.t.dQtQtQtQtQtQt",
"QtQtQtQtQt.#.o.j.k.u.v.w.x.y.m.t.dQtQtQtQtQt",
"QtQtQtQt.#.z.j.p.A.B.l.C.D.E.F.G.n.HQtQtQtQt",
"QtQtQt.#.I.J.K.L.M.N.O.l.B.w.P.m.Q.t.aQtQtQt",
"QtQt.#.R.S.T.U.V.W.X.N.Y.D.Z.0.1.2.3.#.aQtQt",
"QtQt.4.5.6.7.8.9.k#..A.C###a#b.5#c.7.4.9QtQt",
"QtQtQtQtQtQtQt#d#e#f#g.Y#h#a#iQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.#.j#f#j.C.E#a#kQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt#d.j#l#g.Y#m#a#nQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.##o#p#q#r#s#t#kQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt#d#u#v#w.Q#t.3#xQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQt.5.d.d#n.d#n#y.6QtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt",
"QtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQtQt"};


/* 
 *  Constructs a MainWin which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 */
MainWin::MainWin( QWidget* parent,  const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    QPixmap image0( ( const char** ) image0_data );
    QPixmap image1( ( const char** ) image1_data );
    QPixmap image2( ( const char** ) image2_data );
    if ( !name )
	setName( "MainWin" );
    resize( 592, 470 ); 
    setCaption( tr( "MP3 CD Image Creator"  ) );

    AddButton = new QPushButton( this, "AddButton" );
    AddButton->setGeometry( QRect( 400, 170, 108, 32 ) ); 
    AddButton->setText( tr( "Add..."  ) );

/*    DirChooseButton = new QPushButton( this, "DirChooseButton" );
    DirChooseButton->setGeometry( QRect( 430, 370, 40, 40 ) ); 
    DirChooseButton->setText( tr( ""  ) );
    DirChooseButton->setPixmap( image0 );*/

    ImageChooseButton = new QPushButton( this, "ImageChooseButton" );
    ImageChooseButton->setGeometry( QRect( 430, 370, 40, 40 ) ); 
    ImageChooseButton->setText( tr( ""  ) );
    ImageChooseButton->setPixmap( image0 );


    CreateButton = new QPushButton( this, "CreateButton" );
    CreateButton->setGeometry( QRect( 270, 420, 108, 32 ) ); 
    CreateButton->setText( tr( "Create Image"  ) );

    RemoveButton = new QPushButton( this, "RemoveButton" );
    RemoveButton->setGeometry( QRect( 400, 250, 108, 32 ) ); 
    RemoveButton->setText( tr( "Remove"  ) );
    RemoveButton->setEnabled( FALSE );

    DownButton = new QPushButton( this, "DownButton" );
    DownButton->setGeometry( QRect( 430, 300, 50, 50 ) ); 
    DownButton->setText( tr( ""  ) );
    DownButton->setPixmap( image1 );
    DownButton->setMaximumSize( QSize( 32762, 32767 ) );

    TotalSizeLabel = new QLabel( this, "TotalSizeLabel" );
    TotalSizeLabel->setGeometry( QRect( 400, 210, 400, 30 ) ); 
    TotalSizeLabel->setText( tr( "TextLabel1"  ) );
    TotalSizeLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignLeft ) );

   /* LocationTextEntry = new QLineEdit( this, "LocationTextEntry" );
    LocationTextEntry->setGeometry( QRect( 160, 380, 210, 22 ) ); */
    
    ImageLocationEntry = new QLineEdit(this, "ImageLocationEntry");
    ImageLocationEntry->setGeometry(QRect(160, 380, 210, 22));

    /*TempLocationLabel = new QLabel(this, "TempLocationLabel");
    TempLocationLabel->setGeometry(QRect(50, 375, 100, 30));
    TempLocationLabel->setText("Temp Location");*/

    ImageLocationLabel = new QLabel(this, "ImageLocationLabel");
    ImageLocationLabel->setGeometry(QRect(50, 375, 100, 30));
    ImageLocationLabel->setText("Image Location");

    TextLabel1 = new QLabel( this, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 190, 10, 210, 51 ) ); 
    TextLabel1->setText( tr( "Set Up MP3 CD-Image"  ) );
    QFont TextLabel1_font(  TextLabel1->font() );
    TextLabel1_font.setPointSize( 14 );
    TextLabel1_font.setBold( TRUE );
    TextLabel1->setFont( TextLabel1_font ); 
    TextLabel1->setAlignment( int( QLabel::AlignLeft ) );

    UpButton = new QPushButton( this, "UpButton" );
    UpButton->setGeometry( QRect( 430, 100, 50, 50 ) ); 
    UpButton->setText( tr( ""  ) );
    UpButton->setPixmap( image2 );

    ListBox1 = new QListBox( this, "ListBox1" );
    ListBox1->setGeometry( QRect( 50, 90, 321, 270 ) ); 

    // signals and slots connections
    connect( UpButton, SIGNAL( clicked() ), this, SLOT( SlotMoveUp() ) );
    connect( DownButton, SIGNAL( clicked() ), this, SLOT( SlotMoveDown() ) );
    connect( AddButton, SIGNAL( clicked() ), this, SLOT( SlotAdd() ) );
    connect( RemoveButton, SIGNAL( clicked() ), this, SLOT( SlotRemove() ) );
    //connect( DirChooseButton, SIGNAL( clicked() ), this, SLOT( SlotSelectTempLocation() ) );
    connect( CreateButton, SIGNAL( clicked() ), this, SLOT( SlotCreateImage() ) );
    connect(ImageChooseButton, SIGNAL(clicked()), this, SLOT(SlotSelectImageLocation()));

    // tab order
/*    setTabOrder( ListBox1, UpButton );
    setTabOrder( UpButton, AddButton );
    setTabOrder( AddButton, RemoveButton );
    setTabOrder( RemoveButton, DownButton );
    setTabOrder( DownButton, LocationTextEntry );*/

    otherSetup();
}

/*  
 *  Destroys the object and frees any allocated resources
 */
MainWin::~MainWin()
{
    // no need to delete child widgets, Qt does it all for us
}

/*  
 *  Main event handler. Reimplemented to handle application
 *  font changes
 */
bool MainWin::event( QEvent* ev )
{
    bool ret = QWidget::event( ev ); 
    if ( ev->type() == QEvent::ApplicationFontChange ) {
	QFont TextLabel1_font(  TextLabel1->font() );
	TextLabel1_font.setPointSize( 14 );
	TextLabel1_font.setBold( TRUE );
	TextLabel1->setFont( TextLabel1_font ); 
    }
    return ret;
}

